%define mpiimpl openmpi
%define mpidir %_libexecdir/%mpiimpl

%define oname libflame
Name: %oname-devel
Version: r3119
Release: alt3
Summary: Formal Linear Algebra Method Environment
License: LGPL v2.1
Group: Sciences/Mathematics
Url: http://www.cs.utexas.edu/users/flame/
Packager: Eugeny A. Rostovtsev (REAL) <real at altlinux.org>

Source: http://www.cs.utexas.edu/users/flame/snapshots/libflame-r3119.tar.gz
Source1: http://www.cs.utexas.edu/users/flame/book/Downloads/FLAMEC/example.tar.gz

Requires: libatlas-devel liblapack-devel
BuildPreReq: gcc-fortran libatlas-devel liblapack-devel
BuildPreReq: doxygen /usr/bin/dvips texmf(latex/draftcopy)

%description
The objective of the FLAME project is to transform the development of dense
linear algebra libraries from an art reserved for experts to a science that can
be understood by novice and expert alike. Rather than being only a library, the
project encompasses a new notation for expressing algorithms, a methodology for
systematic derivation of algorithms, Application Program Interfaces (APIs) for
representing the algorithms in code, and tools for mechanical derivation,
implementation and analysis of algorithms and implementations.

%package doc
Summary: Documentation for Formal Linear Algebra Method Environment
Group: Development/Documentation
BuildArch: noarch

%description doc
The objective of the FLAME project is to transform the development of dense
linear algebra libraries from an art reserved for experts to a science that can
be understood by novice and expert alike. Rather than being only a library, the
project encompasses a new notation for expressing algorithms, a methodology for
systematic derivation of algorithms, Application Program Interfaces (APIs) for
representing the algorithms in code, and tools for mechanical derivation,
implementation and analysis of algorithms and implementations.

This package contains development documentation for FLAME.

%package -n %oname-example
Summary: Example of using Formal Linear Algebra Method Environment
Group: Development/Other

%description -n %oname-example
The objective of the FLAME project is to transform the development of dense
linear algebra libraries from an art reserved for experts to a science that can
be understood by novice and expert alike. Rather than being only a library, the
project encompasses a new notation for expressing algorithms, a methodology for
systematic derivation of algorithms, Application Program Interfaces (APIs) for
representing the algorithms in code, and tools for mechanical derivation,
implementation and analysis of algorithms and implementations.

This package contains example of using FLAME.

%prep
%setup
tar -xzf %SOURCE1

%build
%add_optflags %optflags_shared
%configure \
	--disable-builtin-lapack-routines \
	--disable-goto-interfaces \
	--enable-verbose-make-output \
	--enable-multithreading=pthreads \
	--enable-supermatrix \
	--enable-supermatrix-visualization
%make_build HOST=%_host

doxygen
pushd docs/%oname
%make_build
popd

%install
%makeinstall HOST=%_host INSTALL_PREFIX=%buildroot%prefix

mv %buildroot%prefix/include-%_arch-%version %buildroot%_includedir
%ifarch x86_64
mv %buildroot%_libexecdir %buildroot%_libdir
%endif
pushd %buildroot%_libdir
for i in libflame liblapack2flame; do
	ln -s $i-%_arch-%version.a $i.a
done
popd

pushd example
%make_build INSTALL_PREFIX=%buildroot%prefix INSTALL_LIBS=%buildroot%_libdir
popd

install -d %buildroot%_docdir/%name
install -d %buildroot%_bindir

install -m644 docs/%oname/%oname.pdf %buildroot%_docdir/%name
mv doxygen/html %buildroot%_docdir/%name/
install -m755 example/*.x %buildroot%_bindir

%files
%doc AUTHORS CHANGELOG CONTRIBUTORS LICENSE
%_libdir/*
%_includedir/*

%files doc
%_docdir/%name

%files -n %oname-example
%doc example/gemm_driver.c example/makefile
%_bindir/*

%changelog
* Mon Jul 06 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> r3119-alt3
- Added texmf(latex/draftcopy) buildreq (fix build of documentation)

* Tue Jun 23 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> r3119-alt2
- Added example

* Tue Jun 23 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> r3119-alt1
- Initial build for Sisyphus

